/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass.provider;

import EEPROM2ndPass.util.EEPROM2ndPassAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class EEPROM2ndPassItemProviderAdapterFactory extends EEPROM2ndPassAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEPROM2ndPassItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.CODEGENERATIONType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CODEGENERATIONTypeItemProvider codegenerationTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.CODEGENERATIONType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCODEGENERATIONTypeAdapter() {
		if (codegenerationTypeItemProvider == null) {
			codegenerationTypeItemProvider = new CODEGENERATIONTypeItemProvider(this);
		}

		return codegenerationTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.CONSISTENCYCHECKERType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CONSISTENCYCHECKERTypeItemProvider consistencycheckerTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.CONSISTENCYCHECKERType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCONSISTENCYCHECKERTypeAdapter() {
		if (consistencycheckerTypeItemProvider == null) {
			consistencycheckerTypeItemProvider = new CONSISTENCYCHECKERTypeItemProvider(this);
		}

		return consistencycheckerTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.DocumentRoot} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRootItemProvider documentRootItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.DocumentRoot}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDocumentRootAdapter() {
		if (documentRootItemProvider == null) {
			documentRootItemProvider = new DocumentRootItemProvider(this);
		}

		return documentRootItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMBLOCKLOCALType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMBLOCKLOCALTypeItemProvider eepromblocklocalTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMBLOCKLOCALType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMBLOCKLOCALTypeAdapter() {
		if (eepromblocklocalTypeItemProvider == null) {
			eepromblocklocalTypeItemProvider = new EEPROMBLOCKLOCALTypeItemProvider(this);
		}

		return eepromblocklocalTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMBLOCKType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMBLOCKTypeItemProvider eepromblockTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMBLOCKType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMBLOCKTypeAdapter() {
		if (eepromblockTypeItemProvider == null) {
			eepromblockTypeItemProvider = new EEPROMBLOCKTypeItemProvider(this);
		}

		return eepromblockTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMDEVICE93Cx6Type} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMDEVICE93Cx6TypeItemProvider eepromdevice93Cx6TypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMDEVICE93Cx6Type}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMDEVICE93Cx6TypeAdapter() {
		if (eepromdevice93Cx6TypeItemProvider == null) {
			eepromdevice93Cx6TypeItemProvider = new EEPROMDEVICE93Cx6TypeItemProvider(this);
		}

		return eepromdevice93Cx6TypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMDEVICEM95xxxType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMDEVICEM95xxxTypeItemProvider eepromdevicem95xxxTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMDEVICEM95xxxType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMDEVICEM95xxxTypeAdapter() {
		if (eepromdevicem95xxxTypeItemProvider == null) {
			eepromdevicem95xxxTypeItemProvider = new EEPROMDEVICEM95xxxTypeItemProvider(this);
		}

		return eepromdevicem95xxxTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMDEVICES12XINTType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMDEVICES12XINTTypeItemProvider eepromdevices12XINTTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMDEVICES12XINTType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMDEVICES12XINTTypeAdapter() {
		if (eepromdevices12XINTTypeItemProvider == null) {
			eepromdevices12XINTTypeItemProvider = new EEPROMDEVICES12XINTTypeItemProvider(this);
		}

		return eepromdevices12XINTTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMDEVICESType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMDEVICESTypeItemProvider eepromdevicesTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMDEVICESType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMDEVICESTypeAdapter() {
		if (eepromdevicesTypeItemProvider == null) {
			eepromdevicesTypeItemProvider = new EEPROMDEVICESTypeItemProvider(this);
		}

		return eepromdevicesTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMMANAGMENTType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMMANAGMENTTypeItemProvider eeprommanagmentTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMMANAGMENTType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMMANAGMENTTypeAdapter() {
		if (eeprommanagmentTypeItemProvider == null) {
			eeprommanagmentTypeItemProvider = new EEPROMMANAGMENTTypeItemProvider(this);
		}

		return eeprommanagmentTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMTypeItemProvider eepromTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMTypeAdapter() {
		if (eepromTypeItemProvider == null) {
			eepromTypeItemProvider = new EEPROMTypeItemProvider(this);
		}

		return eepromTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.EEPROMZONEType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROMZONETypeItemProvider eepromzoneTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.EEPROMZONEType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEEPROMZONETypeAdapter() {
		if (eepromzoneTypeItemProvider == null) {
			eepromzoneTypeItemProvider = new EEPROMZONETypeItemProvider(this);
		}

		return eepromzoneTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link EEPROM2ndPass.TEMPLATEType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TEMPLATETypeItemProvider templateTypeItemProvider;

	/**
	 * This creates an adapter for a {@link EEPROM2ndPass.TEMPLATEType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTEMPLATETypeAdapter() {
		if (templateTypeItemProvider == null) {
			templateTypeItemProvider = new TEMPLATETypeItemProvider(this);
		}

		return templateTypeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (codegenerationTypeItemProvider != null) codegenerationTypeItemProvider.dispose();
		if (consistencycheckerTypeItemProvider != null) consistencycheckerTypeItemProvider.dispose();
		if (documentRootItemProvider != null) documentRootItemProvider.dispose();
		if (eepromblocklocalTypeItemProvider != null) eepromblocklocalTypeItemProvider.dispose();
		if (eepromblockTypeItemProvider != null) eepromblockTypeItemProvider.dispose();
		if (eepromdevice93Cx6TypeItemProvider != null) eepromdevice93Cx6TypeItemProvider.dispose();
		if (eepromdevicem95xxxTypeItemProvider != null) eepromdevicem95xxxTypeItemProvider.dispose();
		if (eepromdevices12XINTTypeItemProvider != null) eepromdevices12XINTTypeItemProvider.dispose();
		if (eepromdevicesTypeItemProvider != null) eepromdevicesTypeItemProvider.dispose();
		if (eeprommanagmentTypeItemProvider != null) eeprommanagmentTypeItemProvider.dispose();
		if (eepromTypeItemProvider != null) eepromTypeItemProvider.dispose();
		if (eepromzoneTypeItemProvider != null) eepromzoneTypeItemProvider.dispose();
		if (templateTypeItemProvider != null) templateTypeItemProvider.dispose();
	}

}
