/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EEPROMBLOCKLOCAL Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getCallBackFunction <em>Call Back Function</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getData <em>Data</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getHasRAMImage <em>Has RAM Image</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getInclude <em>Include</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsReadOnly <em>Is Read Only</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsSecured <em>Is Secured</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getName <em>Name</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getRAMImagePointer <em>RAM Image Pointer</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getStartupInit <em>Startup Init</em>}</li>
 * </ul>
 * </p>
 *
 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType()
 * @model extendedMetaData="name='EEPROM_BLOCK_LOCAL_._type' kind='empty'"
 * @generated
 */
public interface EEPROMBLOCKLOCALType extends EObject {
	/**
	 * Returns the value of the '<em><b>Call Back Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Each EEPROM block must have a notification routine defined:
	 * 
	 * void EEPBLK_Notification_Routine_Name (T_EEPBLK_CODE lub_ErrorCode)
	 * This notification routine will be called each time an EEPROM data inconsistency is detected or an erase block operation is completed.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Call Back Function</em>' attribute.
	 * @see #setCallBackFunction(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_CallBackFunction()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='CallBackFunction' namespace='##targetNamespace'"
	 * @generated
	 */
	String getCallBackFunction();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getCallBackFunction <em>Call Back Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Call Back Function</em>' attribute.
	 * @see #getCallBackFunction()
	 * @generated
	 */
	void setCallBackFunction(String value);

	/**
	 * Returns the value of the '<em><b>Data</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data</em>' attribute.
	 * @see #setData(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_Data()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='Data' namespace='##targetNamespace'"
	 * @generated
	 */
	String getData();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getData <em>Data</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data</em>' attribute.
	 * @see #getData()
	 * @generated
	 */
	void setData(String value);

	/**
	 * Returns the value of the '<em><b>Has RAM Image</b></em>' attribute.
	 * The literals are from the enumeration {@link EEPROM2ndPass.HasRAMImageType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies if the block has a RAM image.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Has RAM Image</em>' attribute.
	 * @see EEPROM2ndPass.HasRAMImageType
	 * @see #isSetHasRAMImage()
	 * @see #unsetHasRAMImage()
	 * @see #setHasRAMImage(HasRAMImageType)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_HasRAMImage()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='HasRAMImage' namespace='##targetNamespace'"
	 * @generated
	 */
	HasRAMImageType getHasRAMImage();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getHasRAMImage <em>Has RAM Image</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Has RAM Image</em>' attribute.
	 * @see EEPROM2ndPass.HasRAMImageType
	 * @see #isSetHasRAMImage()
	 * @see #unsetHasRAMImage()
	 * @see #getHasRAMImage()
	 * @generated
	 */
	void setHasRAMImage(HasRAMImageType value);

	/**
	 * Unsets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getHasRAMImage <em>Has RAM Image</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetHasRAMImage()
	 * @see #getHasRAMImage()
	 * @see #setHasRAMImage(HasRAMImageType)
	 * @generated
	 */
	void unsetHasRAMImage();

	/**
	 * Returns whether the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getHasRAMImage <em>Has RAM Image</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Has RAM Image</em>' attribute is set.
	 * @see #unsetHasRAMImage()
	 * @see #getHasRAMImage()
	 * @see #setHasRAMImage(HasRAMImageType)
	 * @generated
	 */
	boolean isSetHasRAMImage();

	/**
	 * Returns the value of the '<em><b>Include</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The name of the header file that contains references to the RAM image.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Include</em>' attribute.
	 * @see #setInclude(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_Include()
	 * @model dataType="EEPROM2ndPass.IncludeType" required="true"
	 *        extendedMetaData="kind='attribute' name='Include' namespace='##targetNamespace'"
	 * @generated
	 */
	String getInclude();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getInclude <em>Include</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Include</em>' attribute.
	 * @see #getInclude()
	 * @generated
	 */
	void setInclude(String value);

	/**
	 * Returns the value of the '<em><b>Is Read Only</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This type of block is reserved for the blocks that are storing data that dont need to be updated, only reloaded (production code numbers, calibration, etc.). This block type cannot be updated by the EEPROM manager and will not have a RAM image. Only checks are performed on these blocks for ensuring the data security.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Is Read Only</em>' attribute.
	 * @see #setIsReadOnly(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_IsReadOnly()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='IsReadOnly' namespace='##targetNamespace'"
	 * @generated
	 */
	String getIsReadOnly();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsReadOnly <em>Is Read Only</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Read Only</em>' attribute.
	 * @see #getIsReadOnly()
	 * @generated
	 */
	void setIsReadOnly(String value);

	/**
	 * Returns the value of the '<em><b>Is Secured</b></em>' attribute.
	 * The literals are from the enumeration {@link EEPROM2ndPass.IsSecuredType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * For the secured blocks each time a data redundancy check is performed on the block if the block is valid (at least one copy of latest updated zone is valid) another check will be performed for comparing the data stored in EEPROM against the data in the RAM image. If a difference is found and the block is SECURED the ASW is notified.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Is Secured</em>' attribute.
	 * @see EEPROM2ndPass.IsSecuredType
	 * @see #isSetIsSecured()
	 * @see #unsetIsSecured()
	 * @see #setIsSecured(IsSecuredType)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_IsSecured()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='IsSecured' namespace='##targetNamespace'"
	 * @generated
	 */
	IsSecuredType getIsSecured();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsSecured <em>Is Secured</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Secured</em>' attribute.
	 * @see EEPROM2ndPass.IsSecuredType
	 * @see #isSetIsSecured()
	 * @see #unsetIsSecured()
	 * @see #getIsSecured()
	 * @generated
	 */
	void setIsSecured(IsSecuredType value);

	/**
	 * Unsets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsSecured <em>Is Secured</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIsSecured()
	 * @see #getIsSecured()
	 * @see #setIsSecured(IsSecuredType)
	 * @generated
	 */
	void unsetIsSecured();

	/**
	 * Returns whether the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getIsSecured <em>Is Secured</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Is Secured</em>' attribute is set.
	 * @see #unsetIsSecured()
	 * @see #getIsSecured()
	 * @see #setIsSecured(IsSecuredType)
	 * @generated
	 */
	boolean isSetIsSecured();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Name of the block.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_Name()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>RAM Image Pointer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * To update or to reload the data from an EEPROM block the ASW must provide a buffer in RAM where this data to be stored. An EEPROM block can have a dedicated RAM buffer. This is called RAM image. This image will be used by default for updating or reloading the data from EEPROM.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>RAM Image Pointer</em>' attribute.
	 * @see #setRAMImagePointer(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_RAMImagePointer()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='RAMImagePointer' namespace='##targetNamespace'"
	 * @generated
	 */
	String getRAMImagePointer();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getRAMImagePointer <em>RAM Image Pointer</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>RAM Image Pointer</em>' attribute.
	 * @see #getRAMImagePointer()
	 * @generated
	 */
	void setRAMImagePointer(String value);

	/**
	 * Returns the value of the '<em><b>Startup Init</b></em>' attribute.
	 * The literals are from the enumeration {@link EEPROM2ndPass.StartupInitType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * To have a short initialization time the EEPROM block can be initialized at startup or in background.
	 * 
	 * 
	 * 
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Startup Init</em>' attribute.
	 * @see EEPROM2ndPass.StartupInitType
	 * @see #isSetStartupInit()
	 * @see #unsetStartupInit()
	 * @see #setStartupInit(StartupInitType)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKLOCALType_StartupInit()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='StartupInit' namespace='##targetNamespace'"
	 * @generated
	 */
	StartupInitType getStartupInit();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getStartupInit <em>Startup Init</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Startup Init</em>' attribute.
	 * @see EEPROM2ndPass.StartupInitType
	 * @see #isSetStartupInit()
	 * @see #unsetStartupInit()
	 * @see #getStartupInit()
	 * @generated
	 */
	void setStartupInit(StartupInitType value);

	/**
	 * Unsets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getStartupInit <em>Startup Init</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStartupInit()
	 * @see #getStartupInit()
	 * @see #setStartupInit(StartupInitType)
	 * @generated
	 */
	void unsetStartupInit();

	/**
	 * Returns whether the value of the '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType#getStartupInit <em>Startup Init</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Startup Init</em>' attribute is set.
	 * @see #unsetStartupInit()
	 * @see #getStartupInit()
	 * @see #setStartupInit(StartupInitType)
	 * @generated
	 */
	boolean isSetStartupInit();

} // EEPROMBLOCKLOCALType
