/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EEPROMBLOCK Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKType#getEEPROMBLOCKLOCAL <em>EEPROMBLOCKLOCAL</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKType#getNumberOfCopy <em>Number Of Copy</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKType#getNumberOfZone <em>Number Of Zone</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKType#getPriority <em>Priority</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMBLOCKType#getSize <em>Size</em>}</li>
 * </ul>
 * </p>
 *
 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType()
 * @model extendedMetaData="name='EEPROM_BLOCK_._type' kind='elementOnly'"
 * @generated
 */
public interface EEPROMBLOCKType extends EObject {
	/**
	 * Returns the value of the '<em><b>EEPROMBLOCKLOCAL</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EEPROMBLOCKLOCAL</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EEPROMBLOCKLOCAL</em>' containment reference.
	 * @see #setEEPROMBLOCKLOCAL(EEPROMBLOCKLOCALType)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType_EEPROMBLOCKLOCAL()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='EEPROM_BLOCK_LOCAL' namespace='##targetNamespace'"
	 * @generated
	 */
	EEPROMBLOCKLOCALType getEEPROMBLOCKLOCAL();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKType#getEEPROMBLOCKLOCAL <em>EEPROMBLOCKLOCAL</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EEPROMBLOCKLOCAL</em>' containment reference.
	 * @see #getEEPROMBLOCKLOCAL()
	 * @generated
	 */
	void setEEPROMBLOCKLOCAL(EEPROMBLOCKLOCALType value);

	/**
	 * Returns the value of the '<em><b>Number Of Copy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * An EEPROM block can be considered as a bidimensional matrix of images of the same data structure:
	 * 
	 * An EEPROM block can have up to 32 zones. Each zone can have up to 4 redundancy copies.
	 * There can be:
	 * - Single blocks: 1 zone with 1 copy;
	 * - Multi-copy blocks: blocks with more than one copy / zone;
	 * - Multi-zone blocks: blocks with more than one zone;
	 * Compatibility with old EEPROM blocks types: 
	 * - Single: 1 zone/ 1 copy;
	 * - Double: 1 zone / 2 copies;
	 * - Alternate: 2 zones / 1 copy
	 * 
	 * Each copy of a block has an index that keeps the information about the updates history and a checksum for ensuring data retention. The checksum is computed using a specific algorithm on all the data and the update index.
	 * 
	 * If one EEPROM block has more than one zone this will:
	 * - increase the life-spawn of the EEPROM (more updates than the maximum number of writes allowed by the EEPROM component)
	 * - increase the safety for this EEPROM block (there is a valid EEPROM zone any time after a reset has taken place).
	 * Each copy of the same zone contains the same data. For increasing the safety of the block the user can define multiple copies for the zones of an EEPROM block.
	 * If a block has more than one zone each update will be started in the next zone, the zone array of a block being considered as a ring buffer. The update index contained in every copy of a zone will provide information about the zone that was updated latest.
	 * If the block is multi-copy (has more than one copy/zone) and it has at least one valid copy before an update is started the update mechanism will ensure that the block will still have one valid copy if a reset occurs during the update.
	 * The blocks with multiple copies have also the repair ability. Each time a check is performed on a block with multiple copies and not all the copies of the latest updated zone are valid, a repair request will be set and the EEPROM updates management will try to restore the valid data into all the copies of a zone.
	 * 
	 * Note:
	 * A repair request for a block is overwritten by an update request set by the ASW if the repair of the block is pending (not already started).
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Number Of Copy</em>' attribute.
	 * @see #setNumberOfCopy(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType_NumberOfCopy()
	 * @model dataType="EEPROM2ndPass.NumberOfCopyType" required="true"
	 *        extendedMetaData="kind='attribute' name='NumberOfCopy' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getNumberOfCopy();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKType#getNumberOfCopy <em>Number Of Copy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Copy</em>' attribute.
	 * @see #getNumberOfCopy()
	 * @generated
	 */
	void setNumberOfCopy(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Number Of Zone</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * An EEPROM block can be considered as a bidimensional matrix of images of the same data structure:
	 * An EEPROM block can have up to 32 zones. Each zone can have up to 4 redundancy copies.
	 * There can be:
	 * - Single blocks: 1 zone with 1 copy;
	 * - Multi-copy blocks: blocks with more than one copy / zone;
	 * - Multi-zone blocks: blocks with more than one zone;
	 * 
	 * Compatibility with old EEPROM blocks types: 
	 * - Single: 1 zone/ 1 copy;
	 * - Double: 1 zone / 2 copies;
	 * - Alternate: 2 zones / 1 copy
	 * 
	 * Each copy of a block has an index that keeps the information about the updates history and a checksum for ensuring data retention. The checksum is computed using a specific algorithm on all the data and the update index.
	 * 
	 * If one EEPROM block has more than one zone this will:
	 * - increase the life-spawn of the EEPROM (more updates than the maximum number of writes allowed by the EEPROM component)
	 * - increase the safety for this EEPROM block (there is a valid EEPROM zone any time after a reset has taken place).
	 * Each copy of the same zone contains the same data. For increasing the safety of the block the user can define multiple copies for the zones of an EEPROM block.
	 * If a block has more than one zone each update will be started in the next zone, the zone array of a block being considered as a ring buffer. The update index contained in every copy of a zone will provide information about the zone that was updated latest.
	 * If the block is multi-copy (has more than one copy/zone) and it has at least one valid copy before an update is started the update mechanism will ensure that the block will still have one valid copy if a reset occurs during the update.
	 * The blocks with multiple copies have also the repair ability. Each time a check is performed on a block with multiple copies and not all the copies of the latest updated zone are valid, a repair request will be set and the EEPROM updates management will try to restore the valid data into all the copies of a zone.
	 * 
	 * Note:
	 * A repair request for a block is overwritten by an update request set by the ASW if the repair of the block is pending (not already started).
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Number Of Zone</em>' attribute.
	 * @see #setNumberOfZone(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType_NumberOfZone()
	 * @model dataType="EEPROM2ndPass.NumberOfZoneType" required="true"
	 *        extendedMetaData="kind='attribute' name='NumberOfZone' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getNumberOfZone();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKType#getNumberOfZone <em>Number Of Zone</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Zone</em>' attribute.
	 * @see #getNumberOfZone()
	 * @generated
	 */
	void setNumberOfZone(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * If more blocks are scheduled for update the Priority will determine which block will be serviced first.
	 * 
	 * Highest priority is 0x00
	 * Lowest priority is 0xFF
	 * 
	 * Each block has a unique priority.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType_Priority()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='Priority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getPriority();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKType#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The size of the EEPROM block. It usualy the same size as the RAM image data object linked to the block.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Size</em>' attribute.
	 * @see #setSize(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMBLOCKType_Size()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='Size' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSize();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMBLOCKType#getSize <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' attribute.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(BigInteger value);

} // EEPROMBLOCKType
