/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EEPROMDEVICES12XINT Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfEraseWriteRetry <em>Nb Of Erase Write Retry</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfResourceRetry <em>Nb Of Resource Retry</em>}</li>
 * </ul>
 * </p>
 *
 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMDEVICES12XINTType()
 * @model extendedMetaData="name='EEPROM_DEVICE_S12X_INT_._type' kind='empty'"
 * @generated
 */
public interface EEPROMDEVICES12XINTType extends EObject {
	/**
	 * Returns the value of the '<em><b>Nb Of Erase Write Retry</b></em>' attribute.
	 * The default value is <code>"3"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * While the driver writes data to the EEPROM it also reads back the written data in order to see if the data was written ok. In case there was a write/erase error the driver will retry. This configuration defines how many times the driver will retry to write the same address before it calls the callback function with the E_EEP_ERROR parameter.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nb Of Erase Write Retry</em>' attribute.
	 * @see #isSetNbOfEraseWriteRetry()
	 * @see #unsetNbOfEraseWriteRetry()
	 * @see #setNbOfEraseWriteRetry(int)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMDEVICES12XINTType_NbOfEraseWriteRetry()
	 * @model default="3" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Int"
	 *        extendedMetaData="kind='attribute' name='NbOfEraseWriteRetry' namespace='##targetNamespace'"
	 * @generated
	 */
	int getNbOfEraseWriteRetry();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfEraseWriteRetry <em>Nb Of Erase Write Retry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nb Of Erase Write Retry</em>' attribute.
	 * @see #isSetNbOfEraseWriteRetry()
	 * @see #unsetNbOfEraseWriteRetry()
	 * @see #getNbOfEraseWriteRetry()
	 * @generated
	 */
	void setNbOfEraseWriteRetry(int value);

	/**
	 * Unsets the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfEraseWriteRetry <em>Nb Of Erase Write Retry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetNbOfEraseWriteRetry()
	 * @see #getNbOfEraseWriteRetry()
	 * @see #setNbOfEraseWriteRetry(int)
	 * @generated
	 */
	void unsetNbOfEraseWriteRetry();

	/**
	 * Returns whether the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfEraseWriteRetry <em>Nb Of Erase Write Retry</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Nb Of Erase Write Retry</em>' attribute is set.
	 * @see #unsetNbOfEraseWriteRetry()
	 * @see #getNbOfEraseWriteRetry()
	 * @see #setNbOfEraseWriteRetry(int)
	 * @generated
	 */
	boolean isSetNbOfEraseWriteRetry();

	/**
	 * Returns the value of the '<em><b>Nb Of Resource Retry</b></em>' attribute.
	 * The default value is <code>"20"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * There is the possibility that the EEPROM device is busy when the driver tries to use it in order to write/erase some data. In this case the driver will reschedule the write. This configuration defines how many times the write/erase may be rescheduled due to a busy communication channel before the driver calls the callback function with the E_EEP_ERROR parameter.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nb Of Resource Retry</em>' attribute.
	 * @see #isSetNbOfResourceRetry()
	 * @see #unsetNbOfResourceRetry()
	 * @see #setNbOfResourceRetry(int)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMDEVICES12XINTType_NbOfResourceRetry()
	 * @model default="20" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Int"
	 *        extendedMetaData="kind='attribute' name='NbOfResourceRetry' namespace='##targetNamespace'"
	 * @generated
	 */
	int getNbOfResourceRetry();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfResourceRetry <em>Nb Of Resource Retry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nb Of Resource Retry</em>' attribute.
	 * @see #isSetNbOfResourceRetry()
	 * @see #unsetNbOfResourceRetry()
	 * @see #getNbOfResourceRetry()
	 * @generated
	 */
	void setNbOfResourceRetry(int value);

	/**
	 * Unsets the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfResourceRetry <em>Nb Of Resource Retry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetNbOfResourceRetry()
	 * @see #getNbOfResourceRetry()
	 * @see #setNbOfResourceRetry(int)
	 * @generated
	 */
	void unsetNbOfResourceRetry();

	/**
	 * Returns whether the value of the '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType#getNbOfResourceRetry <em>Nb Of Resource Retry</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Nb Of Resource Retry</em>' attribute is set.
	 * @see #unsetNbOfResourceRetry()
	 * @see #getNbOfResourceRetry()
	 * @see #setNbOfResourceRetry(int)
	 * @generated
	 */
	boolean isSetNbOfResourceRetry();

} // EEPROMDEVICES12XINTType
