/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EEPROMZONE Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EEPROM2ndPass.EEPROMZONEType#getEEPROMBLOCK <em>EEPROMBLOCK</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMZONEType#getName <em>Name</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMZONEType#getOffset <em>Offset</em>}</li>
 *   <li>{@link EEPROM2ndPass.EEPROMZONEType#getSize <em>Size</em>}</li>
 * </ul>
 * </p>
 *
 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMZONEType()
 * @model extendedMetaData="name='EEPROM_ZONE_._type' kind='elementOnly'"
 * @generated
 */
public interface EEPROMZONEType extends EObject {
	/**
	 * Returns the value of the '<em><b>EEPROMBLOCK</b></em>' containment reference list.
	 * The list contents are of type {@link EEPROM2ndPass.EEPROMBLOCKType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The order of the block correspond to its position in the XML file
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>EEPROMBLOCK</em>' containment reference list.
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMZONEType_EEPROMBLOCK()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='EEPROM_BLOCK' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<EEPROMBLOCKType> getEEPROMBLOCK();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Name of the EEPROM zone.
	 * A ZONE is an EEPROM range that contains blocks.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMZONEType_Name()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMZONEType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Offset of the zone in the EEPROM memory. First EEPROM address has offet 0.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Offset</em>' attribute.
	 * @see #setOffset(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMZONEType_Offset()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.NonNegativeInteger" required="true"
	 *        extendedMetaData="kind='attribute' name='Offset' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOffset();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMZONEType#getOffset <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Offset</em>' attribute.
	 * @see #getOffset()
	 * @generated
	 */
	void setOffset(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The size of the EEPROM zone.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Size</em>' attribute.
	 * @see #setSize(BigInteger)
	 * @see EEPROM2ndPass.EEPROM2ndPassPackage#getEEPROMZONEType_Size()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.PositiveInteger" required="true"
	 *        extendedMetaData="kind='attribute' name='Size' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSize();

	/**
	 * Sets the value of the '{@link EEPROM2ndPass.EEPROMZONEType#getSize <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' attribute.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(BigInteger value);

} // EEPROMZONEType
