/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package EEPROM2ndPass.util;

import EEPROM2ndPass.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see EEPROM2ndPass.EEPROM2ndPassPackage
 * @generated
 */
public class EEPROM2ndPassAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static EEPROM2ndPassPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEPROM2ndPassAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = EEPROM2ndPassPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EEPROM2ndPassSwitch<Adapter> modelSwitch =
		new EEPROM2ndPassSwitch<Adapter>() {
			@Override
			public Adapter caseCODEGENERATIONType(CODEGENERATIONType object) {
				return createCODEGENERATIONTypeAdapter();
			}
			@Override
			public Adapter caseCONSISTENCYCHECKERType(CONSISTENCYCHECKERType object) {
				return createCONSISTENCYCHECKERTypeAdapter();
			}
			@Override
			public Adapter caseDocumentRoot(DocumentRoot object) {
				return createDocumentRootAdapter();
			}
			@Override
			public Adapter caseEEPROMBLOCKLOCALType(EEPROMBLOCKLOCALType object) {
				return createEEPROMBLOCKLOCALTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMBLOCKType(EEPROMBLOCKType object) {
				return createEEPROMBLOCKTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMDEVICE93Cx6Type(EEPROMDEVICE93Cx6Type object) {
				return createEEPROMDEVICE93Cx6TypeAdapter();
			}
			@Override
			public Adapter caseEEPROMDEVICEM95xxxType(EEPROMDEVICEM95xxxType object) {
				return createEEPROMDEVICEM95xxxTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMDEVICES12XINTType(EEPROMDEVICES12XINTType object) {
				return createEEPROMDEVICES12XINTTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMDEVICESType(EEPROMDEVICESType object) {
				return createEEPROMDEVICESTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMMANAGMENTType(EEPROMMANAGMENTType object) {
				return createEEPROMMANAGMENTTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMType(EEPROMType object) {
				return createEEPROMTypeAdapter();
			}
			@Override
			public Adapter caseEEPROMZONEType(EEPROMZONEType object) {
				return createEEPROMZONETypeAdapter();
			}
			@Override
			public Adapter caseTEMPLATEType(TEMPLATEType object) {
				return createTEMPLATETypeAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.CODEGENERATIONType <em>CODEGENERATION Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.CODEGENERATIONType
	 * @generated
	 */
	public Adapter createCODEGENERATIONTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.CONSISTENCYCHECKERType <em>CONSISTENCYCHECKER Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.CONSISTENCYCHECKERType
	 * @generated
	 */
	public Adapter createCONSISTENCYCHECKERTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.DocumentRoot
	 * @generated
	 */
	public Adapter createDocumentRootAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMBLOCKLOCALType <em>EEPROMBLOCKLOCAL Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMBLOCKLOCALType
	 * @generated
	 */
	public Adapter createEEPROMBLOCKLOCALTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMBLOCKType <em>EEPROMBLOCK Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMBLOCKType
	 * @generated
	 */
	public Adapter createEEPROMBLOCKTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMDEVICE93Cx6Type <em>EEPROMDEVICE93 Cx6 Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMDEVICE93Cx6Type
	 * @generated
	 */
	public Adapter createEEPROMDEVICE93Cx6TypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMDEVICEM95xxxType <em>EEPROMDEVICEM9 5xxx Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMDEVICEM95xxxType
	 * @generated
	 */
	public Adapter createEEPROMDEVICEM95xxxTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMDEVICES12XINTType <em>EEPROMDEVICES12XINT Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMDEVICES12XINTType
	 * @generated
	 */
	public Adapter createEEPROMDEVICES12XINTTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMDEVICESType <em>EEPROMDEVICES Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMDEVICESType
	 * @generated
	 */
	public Adapter createEEPROMDEVICESTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMMANAGMENTType <em>EEPROMMANAGMENT Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMMANAGMENTType
	 * @generated
	 */
	public Adapter createEEPROMMANAGMENTTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMType <em>EEPROM Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMType
	 * @generated
	 */
	public Adapter createEEPROMTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.EEPROMZONEType <em>EEPROMZONE Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.EEPROMZONEType
	 * @generated
	 */
	public Adapter createEEPROMZONETypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link EEPROM2ndPass.TEMPLATEType <em>TEMPLATE Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see EEPROM2ndPass.TEMPLATEType
	 * @generated
	 */
	public Adapter createTEMPLATETypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //EEPROM2ndPassAdapterFactory
